The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::PRCRev Class Reference

Perry's simple reverberator class. More...

`#include <PRCRev.h>`

Inheritance diagram for stk::PRCRev:

List of all members.

## Public Member Functions
| PRCRev (StkFloat T60=1.0)
| Class constructor taking a T60 decay time argument (one second default value).
void | clear (void)
| Reset and clear all internal state.
void | setT60 (StkFloat T60)
| Set the reverberation T60 decay time.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed stereo frame.
StkFloat | tick (StkFloat input, unsigned int channel=0)
| Input one sample to the effect and return the specified `channel` value of the computed stereo frame.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the effect and replace with stereo outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the effect and write stereo outputs to the `oFrames` object.

## Detailed Description

Perry's simple reverberator class.

This class takes a monophonic input signal and produces a stereo output signal. It is based on some of the famous Stanford/CCRMA reverbs (NRev, KipRev), which were based on the Chowning/Moorer/Schroeder reverberators using networks of simple allpass and comb delay filters. This class implements two series allpass units and two parallel comb filters.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Member Function Documentation

StkFloat stk::PRCRev::lastOut | ( | unsigned int | channel = `0` | ) | `[inline]`

Return the specified channel value of the last computed stereo frame.

Use the lastFrame() function to get both values of the last computed stereo frame. The `channel` argument must be 0 or 1 (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00091 {
    00092 #if defined(_STK_DEBUG_)
    00093   if ( channel > 1 ) {
    00094     oStream_ << "PRCRev::lastOut(): channel argument must be less than 2!";
    00095     handleError( StkError::FUNCTION_ARGUMENT );
    00096   }
    00097 #endif
    00098
    00099   return lastFrame_[channel];
    00100 }

StkFloat stk::PRCRev::tick | ( | StkFloat | input,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline]`

Input one sample to the effect and return the specified `channel` value of the computed stereo frame.

Use the lastFrame() function to get both values of the computed stereo output frame. The `channel` argument must be 0 or 1 (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00103 {
    00104 #if defined(_STK_DEBUG_)
    00105   if ( channel > 1 ) {
    00106     oStream_ << "PRCRev::tick(): channel argument must be less than 2!";
    00107     handleError( StkError::FUNCTION_ARGUMENT );
    00108   }
    00109 #endif
    00110
    00111   StkFloat temp, temp0, temp1, temp2, temp3;
    00112
    00113   temp = allpassDelays_[0].lastOut();
    00114   temp0 = allpassCoefficient_ * temp;
    00115   temp0 += input;
    00116   allpassDelays_[0].tick(temp0);
    00117   temp0 = -(allpassCoefficient_ * temp0) + temp;
    00118
    00119   temp = allpassDelays_[1].lastOut();
    00120   temp1 = allpassCoefficient_ * temp;
    00121   temp1 += temp0;
    00122   allpassDelays_[1].tick(temp1);
    00123   temp1 = -(allpassCoefficient_ * temp1) + temp;
    00124
    00125   temp2 = temp1 + ( combCoefficient_[0] * combDelays_[0].lastOut() );
    00126   temp3 = temp1 + ( combCoefficient_[1] * combDelays_[1].lastOut() );
    00127
    00128   lastFrame_[0] = effectMix_ * (combDelays_[0].tick(temp2));
    00129   lastFrame_[1] = effectMix_ * (combDelays_[1].tick(temp3));
    00130   temp = (1.0 - effectMix_) * input;
    00131   lastFrame_[0] += temp;
    00132   lastFrame_[1] += temp;
    00133
    00134   return lastFrame_[channel];
    00135 }

StkFrames& stk::PRCRev::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  |

Take a channel of the StkFrames object as inputs to the effect and replace with stereo outputs.

The StkFrames argument reference is returned. The stereo outputs are written to the StkFrames argument starting at the specified `channel`. Therefore, the `channel` argument must be less than ( channels() - 1 ) of the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

StkFrames& stk::PRCRev::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  |

Take a channel of the `iFrames` object as inputs to the effect and write stereo outputs to the `oFrames` object.

The `iFrames` object reference is returned. The `iChannel` argument must be less than the number of channels in the `iFrames` argument (the first channel is specified by 0). The `oChannel` argument must be less than ( channels() - 1 ) of the `oFrames` argument. However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

The documentation for this class was generated from the following file:

- PRCRev.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.